/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qapplication.h>
#include "form1.h"
#include <stdio.h>
#include <sys/io.h>
#include <termios.h>
#include<string.h>
#include<stdlib.h>
#include <qmessagebox.h>
#include <unistd.h>

void Form1::init()
{
    extern int band;
    extern int freqvalue;
    extern int gainvalue;
    extern char *wsefile[12]; 
    extern int portout;
    extern int portout2;
    FILE * Fp;	
    
    Fp=fopen(*wsefile,"r");   
  
    if (Fp!=NULL)
    {
	fscanf(Fp,"%d %d %d %d",&band,&freqvalue,&gainvalue,&portout);  
	fclose(Fp);    
    }
    else
    {
	band=3;
	freqvalue=000;
	gainvalue=0;
	portout=888;	
	writeFile();
    }
    portout2= portout + 2;
    textLabel_gain->setNum(gainvalue);       
    textLabel_freq->setNum(freqvalue);    
    textLabel_port2->setNum(portout); 
 
    switch (band)
    {
    case 1:
	radioButton18->setChecked(TRUE);
	break;
    case 2:
	radioButton35->setChecked(TRUE);
	break;
    case 3:
	radioButton70->setChecked(TRUE);
	break;
    case 4:
	radioButton100->setChecked(TRUE);
	break;
    case 5:
	radioButton140->setChecked(TRUE);
	break;
    case 6:
	radioButton1440->setChecked(TRUE);
	break;
    case 7:
	radioButton1445->setChecked(TRUE);
	break;
    case 8:
	radioButton1450->setChecked(TRUE);
	break;
    case 9:
	radioButton1455->setChecked(TRUE);
	break;
    default:
	radioButton18->setChecked(TRUE);
    } // switch
    
    switch (portout)
    {
    case 888:
	radioButton11->setChecked(TRUE);
	break;
    case 632:
	radioButton11_2->setChecked(TRUE);
	break;
    default:
	radioButton11->setChecked(TRUE);
	break;
    } //switch
  freqout();
  gainout();
} 


void Form1::closeEvent( QCloseEvent * )
{
    fileExit();    
}

void Form1::writeFile()	
{ 
    extern int band;
    extern int freqvalue;
    extern int gainvalue;
    extern char *wsefileo[12]; 
    extern int portout;
    FILE *Fp;
    
    Fp=fopen(*wsefileo,"w");
    
    fprintf(Fp,"%d\n %d\n %d\n %d\n",band,freqvalue,gainvalue,portout);
    fclose(Fp);    
}


void Form1::fileExit()	
{
    writeFile();
    QApplication::exit( 0 );  
}

void Form1::quitprog()
{
    writeFile();    
    Form1::fileExit();
    return;
}

void Form1::slpt1()
{
    // use decimal addresses for ports throughout program
    extern int portout;
    extern int portout2;
    portout = 888;
    portout2 = portout + 2;
    textLabel_port2->setNum(portout); 
    writeFile();
    }


void Form1::slpt2()
{
    extern int portout;  
    extern int portout2;
    portout = 632;
    portout2 = portout + 2;
    textLabel_port2->setNum(portout); 
    writeFile();
}


void Form1::H18()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    extern int devicecode;
    band=1;
    bit1 = '1' ;
    bit2 = '0' ;
    bit3 = '0' ;
    bit4 = '0' ;
    bit5 = '0' ;
    devicecode = 2;
    bitsout();
    writeFile();
}


void Form1::H35()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    extern int devicecode; 
    band=2;
    bit1 = '0'; 
    bit2 = '1' ;
    bit3 = '0' ;
    bit4 = '0' ;
    bit5 = '0' ;
    devicecode = 2 ;
    bitsout();
    writeFile();
}


void Form1::H70()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    extern int devicecode; 
    band=3;
    bit1 = '0' ;
    bit2 = '0' ;
    bit3 = '1' ;
    bit4 = '0' ;
    bit5 = '0' ;
    devicecode = 2; 
    bitsout();
    writeFile();
}


void Form1::H100()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    extern int devicecode; 
    band=4;
    bit1 = '0'; 
    bit2 = '0' ;
    bit3 = '0' ;
    bit4 = '1' ;
    bit5 = '0' ;
    devicecode = 2;
    bitsout();
    writeFile();
}


void Form1::H140()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    extern int devicecode; 
    band=5;
    bit1 = '0'; 
    bit2 = '0' ;
    bit3 = '0' ;
    bit4 = '0' ;
    bit5 = '1' ;
    devicecode = 2; 
    bitsout();
    writeFile();
}


void Form1::H1440()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern int devicecode; 
    band=6;
    bit1 = '1'; 
    bit2 = '0' ;
    bit3 = '0' ;
    bit4 = '0' ;
    devicecode = 8; 
    bitsout();
    writeFile();
}


void Form1::H1445()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern int devicecode; 
    band=7;
    bit1 = '0'; 
    bit2 = '1' ;
    bit3 = '0' ;
    bit4 = '0' ;
    devicecode = 8; 
    bitsout();
    writeFile();
}


void Form1::H1450()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern int devicecode; 
    band=8; 
    bit1 = '0'; 
    bit2 = '0' ;
    bit3 = '1' ;
    bit4 = '0' ;
    devicecode = 8; 
    bitsout();
    writeFile();
}


void Form1::H1455()
{
    extern int band;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern int devicecode; 
    band=9;
    bit1 = '0'; 
    bit2 = '0' ;
    bit3 = '0' ;
    bit4 = '1' ;
    devicecode = 8; 
    bitsout();
    writeFile();
}


void Form1::frequp()
{
    extern int freqvalue;
    freqvalue=freqvalue+25;
    if (freqvalue>475) 
    {
	freqvalue=0;
    }    
    freqout();
    
    textLabel_freq->setNum(freqvalue);
    writeFile();
}


void Form1::freqdn()
{
    extern int freqvalue;
    freqvalue=freqvalue-25;
    if (freqvalue<0) 
    {
	freqvalue=475;
    }
    freqout();
    textLabel_freq->setNum(freqvalue);
    writeFile();
}


void Form1::gainup()
{
    extern int gainvalue;
    gainvalue=gainvalue+5;
    if (gainvalue>=10) 
    {
	gainvalue=10;
    }
    gainout();
    textLabel_gain->setNum(gainvalue);
    writeFile();
}


void Form1::gaindn()
{
    extern int gainvalue;
    gainvalue=gainvalue-5;
    if (gainvalue<=-15) 
    {
	gainvalue=-15;
    }    
    gainout();
    textLabel_gain->setNum(gainvalue);    
    writeFile();
}



void Form1::gainout()
{	
    extern int devicecode;	
    extern int devicecode1;
    extern int gainvalue;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    
    devicecode1=devicecode;
    devicecode=1;
    
    switch (gainvalue)
    {	
    case -15:	   
	bit1 = '0'; 
	bit2 = '1' ;
	bit3 = '1' ;
	bit4 = '0' ;
	break;
	
    case  -10:	   
	bit1 = '1'; 
	bit2 = '1' ;
	bit3 = '1' ;
	bit4 = '0' ;
	break;
	
    case -5:	   
	bit1 = '0'; 
	bit2 = '0' ;
	bit3 = '1' ;
	bit4 = '1' ;
	break;
	
    case 0:	   
	bit1 = '1'; 
	bit2 = '0' ;
	bit3 = '1' ;
	bit4 = '1' ;
	break;
	
    case 5:	   
	bit1 = '0'; 
	bit2 = '1' ;
	bit3 = '0' ;
	bit4 = '1' ;
	break;
	
    case 10:	       
	bit1 = '1'; 
	bit2 = '1' ;
	bit3 = '0' ;
	bit4 = '1' ;
	break;
	
    default:
	bit1 = '1'; 
	bit2 = '1' ;
	bit3 = '0' ;
	bit4 = '1' ;
    } //switch
    
    bitsout();
    writeFile();
    devicecode=devicecode1;
    
   
}




void Form1::bitsout()
{
    extern int portout;
    extern int portout2;
    extern int devicecode;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    int i;
    int j;
    int count;
    // use decimal addresses for ports
    // send data as decimal integers and 
    // it will set WSE bits appropriately
    // 12 usec pauses needed to allow printer ports
    //  to work properly on my 3.4 G Dell P4
    i=ioperm(portout,2,1);
    j=ioperm(portout2,2,1);
    
    outb(0,portout);
    outb(9,portout2);
    // start sequence
    outb(devicecode,portout); //set select high
    outb(9,portout2); //set clock low
                        //  [clock pin 1 and select pin 17 have reverse logic, 
                        //  so need bit 0 and bit 3 high to set these to low]
    
    if (devicecode==2 || devicecode==32) 
    {
	if (bit5=='0') 
	{    
	    outb(9,portout2); //clock [bit 0] remains low 
	           // and data [bit 3, or '8'] is also low [reverse logic for both]
	    usleep(12); //wait
	    outb(8,portout2); //set clock [bit 0] high, 
	          // keep data [bit 3, or '8' low [reverse logic for both]
	    usleep(12);
	}	
	else if (bit5=='1')
	{
	    outb(1,portout2); //clock [bit 0] remains low, 
	         // but data is set high
	    usleep(12);
	    outb(0,portout2); //set clock [bit 0] high, 
	         // and keep data high
	    usleep(12);
	}
    }
    
    
    if (bit4=='0') 
    {    
	outb(9,portout2);
	  usleep(12);
	outb(8,portout2);
	  usleep(12);
    }	
    else if (bit4=='1')
    {
	outb(1,portout2);
	  usleep(12);
	outb(0,portout2);
	  usleep(12);
    }
    
    
    if (bit3=='0') 
    {    
	outb(9,portout2);
	  usleep(12);
	outb(8,portout2);
	  usleep(12);
    }	
    else if (bit3=='1')
    {
	outb(1,portout2);
	  usleep(12);
	outb(0,portout2);
	  usleep(12);
    }	 
    
    if (bit2=='0') 
    {    
	outb(9,portout2);
	  usleep(12);
	outb(8,portout2);
	 usleep(12);
    }	 
    else if (bit2=='1')
    {
	outb(1,portout2);
	  usleep(12);
	outb(0,portout2);
	  usleep(12);
    }
    
    
    if (bit1=='0') 
    {    
	outb(9,portout2);
	  usleep(12);
	outb(8,portout2);
	  usleep(12);
    }	
    else if (bit1=='1')
    {
	outb(1,portout2);
	  usleep(12);
	outb(0,portout2);
	  usleep(12);
    }
    
    outb(1,portout2);
              usleep(12);
    
    for (count=1; count<=5; count++)
    {
	count=count;
	outb(0,portout);
	  usleep(12);
    }    
    
    for (count=1;count<=5;count++)
    {
	count=count;
	outb(devicecode,portout);
	  usleep(12);
    }    
    
    writeFile();
}    

void Form1::freqout()
{	
    extern int freqvalue;	
    extern int devicecode;
    extern char bit1;
    extern char bit2;
    extern char bit3;
    extern char bit4;
    extern char bit5;
    
    
    if (freqvalue==75 || freqvalue==175 || freqvalue==275 || freqvalue==375 || freqvalue==475)
    {	
	bit1 = '1' ;
	bit2 = '0' ;
	bit3 = '0' ;
	bit4 = '0' ;
	devicecode = 16 ;
	bitsout();
    }
    
    else if (freqvalue==0 || freqvalue==100 || freqvalue==200 || freqvalue==300 || freqvalue==400)
    { 
	bit1 = '0' ;
	bit2 = '1' ;
	bit3 = '0' ;
	bit4 = '0' ;
	devicecode = 16 ;
	bitsout();
    } 
    
    else if (freqvalue==25 || freqvalue==125 || freqvalue==225 || freqvalue==325 || freqvalue==425)
    { 
	bit1 = '0' ;
	bit2 = '0' ;
	bit3 = '1' ;
	bit4 = '0' ;
	devicecode = 16; 
	bitsout();
    }
    
    else if (freqvalue==50 ||  freqvalue==150 || freqvalue==250 || freqvalue==350 || freqvalue==450)
    { 
	bit1 = '0' ;
	bit2 = '0' ;
	bit3 = '0' ;
	bit4 = '1' ;
	devicecode = 16 ;
	bitsout();
    } 
    
    if ((freqvalue < 75) || (freqvalue==475))
    {
	bit1 = '1' ;
	bit2 = '0' ;
	bit3 = '0' ;
	bit4 = '0' ;
	bit5 = '0' ;
	devicecode = 32 ;
	bitsout();
    }
    
    else if ((freqvalue > 50) && (freqvalue < 175))
    {
	bit1 = '0' ;
	bit2 = '1' ;
	bit3 = '0' ;
	bit4 = '0' ;
	bit5 = '0' ;
	devicecode =32 ;
	bitsout();
    }
    
    else if ((freqvalue > 150) && (freqvalue < 275))
    {
	bit1 = '0' ;
	bit2 = '0' ;
	bit3 = '1' ;
	bit4 = '0' ;
	bit5 = '0' ;
	devicecode = 32 ;
	bitsout();
    }
    
    else if ((freqvalue > 250) && (freqvalue < 375))
    {
	bit1 = '0' ;
	bit2 = '0' ;
	bit3 = '0' ;
	bit4 = '1' ;
	bit5 = '0' ;
	devicecode = 32 ;
	bitsout();
    }
    
    else if ((freqvalue > 350) && (freqvalue < 475))
    {
	bit1 = '0' ;
	bit2 = '0' ;
	bit3 = '0' ;
	bit4 = '0' ;
	bit5 = '1' ;
	devicecode = 32 ;
	bitsout();
    } 
    
    writeFile(); 
}


void Form1::again()
{
    extern int band;    
    switch (band)
    {
    case 1:
	H18();
	break;
    case 2:   
	H35();
	break;
    case 3:
	H70();
	break;
    case 4:
	H100();
	break;
    case 5:
	H140();
	break;
    case 6:
	H1440();
	break;
    case 7:
	H1445();
	break;
    case 8:
	H1450();
	break;
    case 9:
	H1455();
	break;
    default:
	
	break;
    } //switch     
    
    freqout();
    usleep(25);
    gainout();
}



